//####
//# Legal Notice :
//#    Copyright, Harman International, 2015
//#    Private, proprietary information, the sole property of Harman.  The
//#    contents, ideas, and concepts expressed herein are not to be disclosed
//#    except within the confines of a confidential relationship and only
//#    then on a need to know basis.
//#
//#    Any entity in possession of this Harman Software shall not, and shall not
//#    permit any other person to, disclose, display, loan, publish, transfer
//#    (whether by sale, assignment, exchange, gift, operation of law or
//#    otherwise), license, sublicense, copy, or otherwise disseminate this
//#    Harman Software.
//#
//#    This Harman Software is owned by Harman and is protected by United States
//#    copyright laws, patent laws, international treaty provisions, and/or
//#    state of Texas trade secret laws.
//#
//#    Portions of this Harman Software may, from time to time, include
//#    pre-release code and such code may not be at the level of performance,
//#    compatibility and functionality of the final code. The pre-release code
//#    may not operate correctly and may be substantially modified prior to
//#    final release or certain features may not be generally released. Harman is
//#    not obligated to make or support any pre-release code. All pre-release
//#    code is provided "as is" with no warranties.
//#
//#    This Harman Software is provided with restricted rights. Use, duplication,
//#    or disclosure by the Government is subject to restrictions as set forth
//#    in subparagraph (1)(ii) of The Rights in Technical Data and Computer
//#    Software clause at DFARS 252.227-7013 or subparagraphs (1) and (2) of
//#    the Commercial Computer Software Restricted Rights at 48 CFR 52.227-19,
//#    as applicable.
//####

PROGRAM_NAME='MASTER'

DEFINE_DEVICE 
dvTP = 11112:1:0

DEFINE_CONSTANT
//dropTargets
INTEGER btnDT 	= 17
//draggables
INTEGER btnDG1	= 1
INTEGER btnDG2	= 2
INTEGER btnDG3	= 3
INTEGER btnDG4	= 4

DEFINE_VARIABLE
//an array to store our draggable buttons
INTEGER dgBTNS[] = {btnDG1 ,btnDG2 ,btnDG3 ,btnDG4}
//to store draggable address from start event
INTEGER nDragAddress = 0

DEFINE_MUTUALLY_EXCLUSIVE
([dvTP,1]..[dvTP,4])

//In this example the groups are defined as follows
//	- buttonAddresses 1,2, are assigned: group_1
//	- buttonAddresses 3,4 are assigned: group_2
// 	- btnDT [17] will accept draggables from: group_2

DEFINE_EVENT

DATA_EVENT[dvTP]
{
    ONLINE:
    {
	//Let's make sure we are starting in state 1
	SEND_COMMAND dvTP,"'^ANI-',ITOA(btnDT),',1,1,0'"
    }
}

//Custom event for START [1410]
//Any time a draggable is initiated (long press, dragShadow appears)
//a START event is sent.
//CUSTOM_EVENT[dvTP,ID,Type]
CUSTOM_EVENT[dvTP,dgBTNS,1410]
{
    //Get the dragButtonAddress from the customEvent
    nDragAddress = custom.ID 
    SEND_COMMAND dvTP,"'^ANI-',ITOA(btnDT),',2,2,0'"    
}
//Custom event for ENTER [1411]
//Once the dragShadow enters the boundaries of a valid dropTarget
//a ENTER event is sent
CUSTOM_EVENT[dvTP,btnDT,1411]
{
    SEND_COMMAND dvTP,"'^ANI-',ITOA(btnDT),',2,2,0'"
}
//Custom event for EXIT [1412]
//Once the dragShadow leaves the boundaries of a valid dropTarget
//a EXIT event is sent
CUSTOM_EVENT[dvTP,btnDT,1412]
{
   SEND_COMMAND dvTP,"'^ANI-',ITOA(btnDT),',1,1,0'"
}
//Custom event for DROP [1413]
//A DROP event occurs when a draggable has been released within the boundaries
//of a valid dropTarget.  A valid dropTarget is a dropTarget that has a group
//which the draggable is assigned to.
CUSTOM_EVENT[dvTP,btnDT,1413]
{
    SEND_COMMAND dvTP,"'^ANI-',ITOA(btnDT),',1,1,0'"
    //turn on the source(draggable)
    ON[dvTP,nDragAddress]
}
//Custom event for CANCEL [1414]
//A CANCEL event occurs when a draggable has been released over anything that
//is not a VALID dropTarget.
CUSTOM_EVENT[dvTP,dgBTNS,1414]
{
    SEND_COMMAND dvTP,"'^ANI-',ITOA(btnDT),',1,1,0'"   
}

BUTTON_EVENT[dvTP,8] //CLEAR VTC SOURCES
{
  PUSH:
  {
    OFF[dvTP,1]
    OFF[dvTP,2]
    OFF[dvTP,3]
    OFF[dvTP,4]
    SEND_COMMAND dvTP,"'^ANI-',ITOA(btnDT),',1,1,0'"
  }
}
